// ChildView.h : interface of the CChildView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHILDVIEW_H__2BABEDDE_1933_4801_B693_9B70D40AC25C__INCLUDED_)
#define AFX_CHILDVIEW_H__2BABEDDE_1933_4801_B693_9B70D40AC25C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/////////////////////////////////////////////////////////////////////////////
// CChildView window

class CChildView : public CWnd
{
// Construction
public:
	CChildView();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChildView)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CChildView();
   int GetCurrentXPos() { return mCurX; }

	// Generated message map functions
protected:
	//{{AFX_MSG(CChildView)
	afx_msg void OnPaint();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnEditDecreasetrackoctave();
	afx_msg void OnEditIncreasetrackoctave();
	afx_msg void OnPlayCurrentpattern();
	afx_msg void OnPlaySong();
	afx_msg void OnFileExporttestrom();
	afx_msg void OnFileSave();
	afx_msg void OnFileOpen();
	afx_msg void OnFileNewproject();
	afx_msg void OnFileImportmod();
	afx_msg void OnFileExportMVS0();
	afx_msg void OnFileExportMdTestRom();

	afx_msg void OnPlayStop();
	afx_msg void OnPhButPlayAll();
	afx_msg void OnPhButPlay();
	afx_msg void OnPhButStop();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

   // Pattern Editor functions
   void PatEd_DrawPattern(CDC *devc);
   void PatEd_DrawHeader(CDC *devc);
   void PatEd_DrawCursor();
   void PatEd_CheckNote(UINT nChar);
   void PatEd_CheckEffect(UINT nChar);
   void PatEd_CheckValue(UINT nChar);
   void PatEd_CheckOct(UINT nChar);
   void PatEd_CheckVoice(UINT nChar);
   void PatEd_MoveCursor(UINT nChar);
   void PatEd_RedrawRow(int Row, int ChanNum);
   void PatEd_OnPatternPlay();

   int GetHighestInstrNo();
   int BuildSong();
   void ConvertPitchValue(int Pitch, int Pattern, int Row, int Channel, int * pNote, int * pOct);

private:
   // pattern variables
   int mFirstRow;

   // all of the patterns
   CPattern * mpCurPattern;
   COLORREF mcrMain;
   COLORREF mcrMain5;
   COLORREF mcrHeader;
   int mCurX;
   int mCurRow;
   bool mhdrEditMode;
   int mhdrPatternNum;

   int m_LastInstrPlayed;
};




/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHILDVIEW_H__2BABEDDE_1933_4801_B693_9B70D40AC25C__INCLUDED_)
