//
// Global Variables.
//
//

#pragma once

#include "constants.h"
#include "mainfrm.h"
#include "instredit.h"
#include "rommaker.h"
#include "voice.h"

class Global
{
   public:
      Global()  { }
      ~Global() { }

   static CString ReadNullTerminatedString(CFile * fStream);

   public:
      static CInstrEdit * pInstrEdit;
      static CROMMaker * pROMMaker;
      static CMainFrame * pMainFrm;

      static CVoice VoiceArray[MAX_VOICES]; // voice 1-31; no zero!
      static CPattern Patterns[MAX_PATTERNS];
      static int NumPatterns;
      static bool bChannelActive[MAX_CHANNELS];
      static PATCHANNEL Clipboard[MAX_CHANNELS];
      static bool bQwertyLayout;
};

