// ******************************************************************
//
// ROM Maker Helper class
//
// ******************************************************************

#pragma once

#include "constants.h"
#include "voice.h"


class CROMMakerHelper
{
public:
   bool LoadMusic(CString PathName, CString Filename);
   int GetModuleSize();
   void StoreMusic(CFile * fWrite);
   CString GetFilename() { return m_Filename; }

private:
   int GetHighestInstrNo();

   CString m_Filename;
   CVoice m_VoiceArray[MAX_VOICES];
   BYTE m_SongLen;
   BYTE m_SongOrder[MAX_SONG_LEN];
   BYTE m_NumPatterns;
   CPattern m_Patterns[MAX_PATTERNS];
};


