#if !defined(AFX_INSTREDIT_H__546A04AF_BB05_441C_AED6_B54CD5DCDDE0__INCLUDED_)
#define AFX_INSTREDIT_H__546A04AF_BB05_441C_AED6_B54CD5DCDDE0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// InstrEdit.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CInstrEdit dialog
#include "resource.h"


class CInstrEdit : public CDialog
{
// Construction
public:
	CInstrEdit(CWnd* pParent = NULL);   // standard constructor
   void UpdateSelection(int Selection);

// Dialog Data
	//{{AFX_DATA(CInstrEdit)
	enum { IDD = IDD_DLG_INSTR_EDIT };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CInstrEdit)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CInstrEdit)
	afx_msg void OnIeScale();
	afx_msg void OnIeSilence();
	afx_msg void OnIeRename();
	afx_msg void OnIeLoad();
	afx_msg void OnIeSave();
	afx_msg void OnIeClose();
	afx_msg void OnIeStore();
	afx_msg void OnSelchangeIePresetList();
	afx_msg void OnIeClear();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
   void InitialiseCombo(); // fills the combo with the preset instruments
   void PopulateInstr(unsigned char * Instr); // fills edit boxes with presets
   void BuildandCheckInstr(); // fills CurrentInstr[] if diff and sends data to YM
   void BuildInstrArray(unsigned char * DisplayInstr);

   CWnd * m_pParent;

   unsigned char m_CurrentInstr[INSTRLEN];
   int m_CurrentSelection; // updated when a new instrument is selected
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_INSTREDIT_H__546A04AF_BB05_441C_AED6_B54CD5DCDDE0__INCLUDED_)
