// ******************************************************************
//
// Voice handler class
//
// ******************************************************************

#pragma once

#include "constants.h"


class CVoice
{
public:
   CVoice() { Clear(); }
   virtual ~CVoice() { }

   void GetInstr(unsigned char * pInstr)
   { for (int i=0; i<INSTRLEN; i++) pInstr[i] = m_Instr[i]; }
   void SetInstr(unsigned char * pInstr)
   { for (int i=0; i<INSTRLEN; i++) m_Instr[i] = pInstr[i]; }
   void Clear()
   { for (int i=0; i<INSTRLEN; i++) m_Instr[i] = 0; }
   CString GetName() { return m_Name; }
   void SetName(CString Name) { m_Name = Name; }

private:
   unsigned char m_Instr[INSTRLEN];

   CString m_Name;
};
