#if !defined(AFX_ROMMAKER_H__019D8B4C_CA4A_4B48_9C6F_471DC29E49BF__INCLUDED_)
#define AFX_ROMMAKER_H__019D8B4C_CA4A_4B48_9C6F_471DC29E49BF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ROMMaker.h : header file
//

#include "DirTreeCtrl.h"
#include "ROMMakerHelper.h"
#include "SampleEncoding.h"


/////////////////////////////////////////////////////////////////////////////
// ROMMaker dialog

class CROMMaker : public CDialog
{
// Construction
public:
	CROMMaker(CWnd* pParent = NULL);   // standard constructor
   ~CROMMaker();

// Dialog Data
	//{{AFX_DATA(CROMMaker)
	enum { IDD = IDD_ROM_MAKER };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CROMMaker)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL


// Implementation
protected:
   void UpdateSpaceRemaining();
   void MakeV1();
   void MakeM1();
   void MakeHeaderFile();
   

	// Generated message map functions
	//{{AFX_MSG(CROMMaker)
	virtual void OnCancel();
	afx_msg void OnRmAdd();
	afx_msg void OnRmRemove();
	virtual BOOL OnInitDialog();
	afx_msg void OnRmMakeroms();
	afx_msg void OnSelchangeRmMusicfiles();
	afx_msg void OnSelchangeRmSamplefiles();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

   CWnd * mpParent;
   CDirTreeCtrl m_TreeCtrl;
   CList<CROMMakerHelper*, CROMMakerHelper*> m_MusModules;
   CList<CSampleEncoding*, CSampleEncoding*> m_SampModules;
   
   WORD m_SampleTable[SIZE_SAMPLETABLE];
   WORD m_V1ROMPos; // index into above

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ROMMAKER_H__019D8B4C_CA4A_4B48_9C6F_471DC29E49BF__INCLUDED_)
